opal/memoryhooks/memory.h File Reference.TH "opal/memoryhooks/memory.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
opal/memoryhooks/memory.h \- Hooks for catching release of memory from the current process. 
.SH SYNOPSIS
.br
.PP
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef void() \fBopal_mem_free_unpin_fn_t\fP (void *buf, size_t length, void *cbdata)"
.br
.RI "\fICallback when memory is about to be released by the process. \fP"
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "int \fBopal_mem_free_init\fP (void)"
.br
.ti -1c
.RI "int \fBopal_mem_free_finalize\fP (void)"
.br
.ti -1c
.RI "bool \fBopal_mem_free_is_supported\fP (void)"
.br
.RI "\fIQuery functionality of memory callbacks. \fP"
.ti -1c
.RI "int \fBopal_mem_free_register_handler\fP (\fBopal_mem_free_unpin_fn_t\fP *func, void *cbdata)"
.br
.RI "\fIRegister callback for when memory is to be released. \fP"
.ti -1c
.RI "int \fBopal_mem_free_unregister_handler\fP (\fBopal_mem_free_unpin_fn_t\fP *func)"
.br
.RI "\fIUnregister previously registered callback. \fP"
.in -1c
.SH "Detailed Description"
.PP 
Hooks for catching release of memory from the current process. 

Hooks for catching the release of memory from the current process. For linking reasons, this is not a component framework (some of these require tight coupling into libopal and the wrapper compilers and that entire stack).
.SH "Typedef Documentation"
.PP 
.SS "typedef void() \fBopal_mem_free_unpin_fn_t\fP(void *buf, size_t length, void *cbdata)"
.PP
Callback when memory is about to be released by the process. 
.PP
Callback when the process is about to release memory (but before it actually does so). It is not specified whether this means that free() is being called on that piece of memory and the memory may remain associated with the process or if the memory is being given back to the system through sbrk() or munmap().
.PP
\fBParameters:\fP
.RS 4
\fIbuf\fP Pointer to the start of the allocation to be released 
.br
\fIlentgh\fP Length of the allocation to be released (starting at \fCbuf\fP) 
.br
\fIcbdata\fP Pointer-length of information passed to the handler registration function. 
.RE
.PP

.SH "Function Documentation"
.PP 
.SS "bool opal_mem_free_is_supported (void)"
.PP
Query functionality of memory callbacks. 
.PP
Query whether the system is capable of providing callbacks when memory is about to be released by a process.
.PP
\fBReturn values:\fP
.RS 4
\fItrue\fP \fBopal_mem_free_register_handler()\fP will not return \fCOMPI_ERR_NOT_SUPPORTED\fP. 
.br
\fIfalse\fP \fBopal_mem_free_register_handler()\fP will always return \fCOMPI_ERR_NOT_SUPPORTED\fP.
.RE
.PP
\fBNote:\fP
.RS 4
There is no reason you have to call this function before calling \fBopal_mem_free_register_handler()\fP. It exists for component selection logic that may want to see what the status of the memory hook support is without actually registering anything. 
.RE
.PP

.SS "int opal_mem_free_register_handler (\fBopal_mem_free_unpin_fn_t\fP * func, void * cbdata)"
.PP
Register callback for when memory is to be released. 
.PP
Register a \fCopal_memory_unpin_fn_t\fP function pointer to be called whenever the current process is about to release memory.
.PP
\fBParameters:\fP
.RS 4
\fIfunc\fP Function pointer to call when memory is to be released 
.br
\fIcbdata\fP A pointer-length field to be passed to func when it is invoked.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_SUCCESS\fP The registration completed successfully. 
.br
\fIOMPI_EXISTS\fP The function is already registered and will not be registered again. 
.br
\fIOMPI_ERR_NOT_SUPPORTED\fP There are no hooks available for receiving callbacks when memory is to be released 
.RE
.PP

.SS "int opal_mem_free_unregister_handler (\fBopal_mem_free_unpin_fn_t\fP * func)"
.PP
Unregister previously registered callback. 
.PP
Unregister previously registered callback.
.PP
\fBParameters:\fP
.RS 4
\fIfunc\fP Function pointer to registered callback to remove
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_SUCCESS\fP The function was successfully deregistered 
.br
\fIOMPI_ERR_NOT_FOUND\fP The function was not previously registered 
.RE
.PP

.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
